#!/usr/bin/perl -w
#
# ssiparser.cgi - a simple handler for parsing include virtual SSIs

require 5.001;

MAIN:
{
    print "Content-type: text/html\n\n";

    # This clause handles the hander being called with '/cgi/action.cgi?url='
    # rather than '/cgi/action.cgi'. Some servers use wrappers that overwrite
    # the values of PATH_INFO and PATH_TRANSLATED so we have to
    # set QUERY_STRING by tacking on a '?url=' instead to get the requested
    # URL into the handler.
    if ($ENV{'QUERY_STRING'} && $ENV{'QUERY_STRING'}=~/^url=([^?]*)/) {
        $ENV{'PATH_INFO'}=$1;
        $ENV{'PATH_TRANSLATED'}=$ENV{'DOCUMENT_ROOT'}.$1;
    }

    # Get the text to be processed
    my $textref=Read($ENV{'PATH_TRANSLATED'});

    # Do horrible things to it
    ProcessSSI($textref);
    # Spit it out
    print $$textref;
}

# Read a file
sub Read {
    open(FILE,shift) || do { print "File Not Found\n"; exit; };
    undef $/; #unset line delimiter to read while file in one go
    my $text=<FILE>;
    close(FILE);
    $/="\n"; #restore $/

    return \$text;
}

# Do Server-Side-Include substitution
sub ProcessSSI {
    my $textref=shift;

    # match on all server-side include tags. Replace each tag with a defined string
    while ($$textref=~s/<!--\#(\w+)\s+(\w+)=(?:'|")(.*?)(?:"|')-->/INCLUDE/s) {
        if ($1 eq 'include') {
            if ($2 eq 'virtual') {
                # calculate location of included file
                my $file=$ENV{'DOCUMENT_ROOT'}.$3;
                # if it's executable, run it, otherwise include it
                if (-x $file) {
                    # replace defined string with output of file, removing Content header
                    my $include=`$file`;
                    $include=~/^\s*Content-type:\s+text\/html\s*/gs &&
                        $$textref=~s/INCLUDE/substr $include,pos($include)/es;
                } else {
                    # replace defined string with contents of file
                    my $incref=Read($file);
                    $$textref=~s/INCLUDE/$$incref/s;
                }
            }
        }
    }
}
