import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class FormServlet extends HttpServlet
{
  public void doGet(HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException
  {
    PrintWriter out = new PrintWriter(response.getWriter());
    response.setContentType("text/html");
    try {
      printHeader(out, "Form Servlet");
      printForm(out);
      printFooter(out);
    } catch (Exception e) {
      handleException(out, e);
    }
    out.close();
  }
  
  public void doPost(HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException
  {
    PrintWriter out = new PrintWriter(response.getWriter());
    response.setContentType("text/html");
    try {
      printHeader(out, "Form Servlet");
      String number = request.getParameter("number");
      if (number == null)
      	number = "";
      try {
	    int value = Integer.parseInt(number);
	    String property;
	    if (value == 0)
	    	property = "zero";
	    else if (value % 2 == 0)
	    	property = "even";
	    else
	    	property = "odd";
    	out.println("<p>The integer " + value + " is " + property + ".</p>");
	  } catch (NumberFormatException e) {
	  	out.println("<p>Please enter a number.</p>");
	  }
	  printForm(out);
      printFooter(out);
    } catch (Exception e) {
      handleException(out, e);
    }
    out.close();
  }

  private void handleException(PrintWriter out, Exception e)
    throws IOException
  {  
    printHeader(out, "Error");
    printException(out, e);
    printFooter(out);
  }
  
  private void printForm(PrintWriter out)
  {
      out.println("<form method=\"post\" action=\"/example/FormServlet\">");
      out.println("<p>Enter an integer: <input type=\"text\" name=\"number\"></p>");
      out.println("<input type=\"submit\" name=\"submit\" value=\"Submit\">");
      out.println("</form>");
  }
  
  private void printHeader(PrintWriter out, String title)
    throws IOException
  {
    out.println("<html>");
    out.println("<head>");
    out.println("<title>");
    out.println(title);
    out.println("</title>");
    out.println("</head>");
    out.println("<body>");
    out.println("<h1>");
    out.println(title);
    out.println("</h1>");
  }
  
  private void printFooter(PrintWriter out)
    throws IOException
  {
    out.println("</body>");
    out.println("</html>");
  }
  
  private void printException(PrintWriter out, Exception e)
    throws IOException
  {
    out.println("<p>An error occurred.</p>");
    out.println("<pre>");
    e.printStackTrace(out);
    out.println("</pre>");
  }
}
