#!/usr/bin/perl -Tw

# enable autoflush to prevent buffering
$|=1;

# define a hash for the keys and values
my %map;

# read map file
open (MAP,"/usr/local/apache/rewritemaps/system.map");
while (<MAP>) {
# skip comments
next if /^#/;
# extract the key and value
/(\w+)\s*(\w+)/ and $map{$1}=$2;
}
close (MAP);

# loop forever
while (<STDIN>) {
# look up the key in the hash
my $value=$map{$_}?$map{$_}:"";
# print out the value, with a newline
print "$value\n";
}
